package chapter4.basics;

import javafx.application.Application;
import javafx.event.ActionEvent;
import javafx.geometry.*;
import javafx.stage.Stage;
import javafx.scene.Scene;
import javafx.scene.control.*;
import javafx.scene.layout.*;

public class CounterDelayed extends Application
{
    protected Label label;
    protected int counter;

    protected void increment()
    {
        for(int i = 1; i <= 10; i++)
        {
            counter++;
            String message = "" + counter;
            System.out.println(message);
            label.setText(message);
            try
            {
                Thread.sleep(1000);
            }
            catch(InterruptedException e)
            {
            }
        }
    }

    private void reset()
    {
        counter = 0;
        String message = "" + counter;
        System.out.println(message);
        label.setText(message);
    }

    public void start(Stage primaryStage)
    {
        label = new Label();
        Button b1 = new Button("Erhhen");
        b1.setOnAction((ActionEvent e) -> increment());
        Button b2 = new Button("Zurcksetzen");
        b2.setOnAction(e -> reset());
        VBox root = new VBox(10);
        Insets padding = new Insets(10);
        root.setPadding(padding);
        root.getChildren().add(label);
        root.getChildren().add(b1);
        root.getChildren().add(b2);
        reset();

        Scene scene = new Scene(root);
        primaryStage.setScene(scene);
        primaryStage.setTitle("Zhler");
        primaryStage.show();
    }

    public static void main(String[] args)
    {
        launch(args);
    }
}
