package chapter5.tcp;

import java.net.*;

public class TCPCounterServerWithTimeout
{
    private static final int TIMEOUT = 3_000;

    public static void main(String[] args)
    {
        int counter = 0;

        try(ServerSocket serverSocket = new ServerSocket(1250))
        {
            //serverSocket.setSoTimeout(TIMEOUT);
            while(true)
            {
                // wait for connection then create streams
                System.out.println("waiting for client connection");
                try(TCPSocket tcpSocket = new TCPSocket(serverSocket.accept()))
                {
                    tcpSocket.setTimeout(TIMEOUT);
                    // execute client requests
                    while(true)
                    {
                        String request = tcpSocket.receiveLine();
                        if(request != null)
                        {
                            if(request.equals("increment"))
                            {
                                // perform increment operation
                                counter++;
                            }
                            else if(request.equals("reset"))
                            {
                                // perform reset operation
                                counter = 0;
                                System.out.println("counter has been reset");
                            }
                            String result = String.valueOf(counter);
                            tcpSocket.sendLine(result);
                        }
                        else
                        {
                            System.out.println("closing connection");
                            break;
                        }
                    }
                }
                catch(Exception e)
                {
                    System.out.println(e);
                }
            }
        }
        catch(Exception e)
        {
            System.out.println(e);
        }
    }
}
