package chapter5.udp;

import java.io.*;
import java.net.*;

public class UDPMulticastSocket extends UDPSocket
{
    public UDPMulticastSocket(int port) throws IOException
    {
        super(new MulticastSocket(port));
    }

    public void join(String mcAddress, int port) throws IOException
    {
        InetSocketAddress group = new InetSocketAddress(mcAddress, port);
        ((MulticastSocket) socket).joinGroup(group, null);
    }

    public void leave(String mcAddress, int port) throws IOException
    {
        InetSocketAddress group = new InetSocketAddress(mcAddress, port);
        ((MulticastSocket) socket).leaveGroup(group, null);
    }
}
