package chapter8.jsf.tictactoe;

public class Board
{
    public static final Boolean CIRCLE = Boolean.TRUE; // Rechner
    public static final Boolean CROSS = Boolean.FALSE; // Spieler
    public static final Boolean EMPTY = null;
    
    private static final int GOOD_MOVES[] =
    { 4, 0, 2, 6, 8, 1, 3, 5, 7 };

    private static final int[][] WINSITUATION = new int[][]
    {
        { 0, 1, 2 },
        { 3, 4, 5 },
        { 6, 7, 8 },
        { 0, 3, 6 },
        { 1, 4, 7 },
        { 2, 5, 8 },
        { 0, 4, 8 },
        { 6, 4, 2 } 
    };

    private Boolean[] field;
    private boolean finished = false;

    public Board()
    {
        super();
        field = new Boolean[9];
        for(int i = 0; i < field.length; i++)
        {
            field[i] = EMPTY;
        }
    }

    private boolean hasWon(Boolean symbol)
    {
        for(int i = 0; i < WINSITUATION.length; i++)
        {
            int[] won = WINSITUATION[i];
            if(field[won[0]] == symbol && field[won[1]] == symbol && field[won[2]] == symbol)
            {
                finished = true;
                return true;
            }
        }
        return false;
    }

    public boolean hasWon()
    {
        return hasWon(CIRCLE);
    }

    public boolean hasLost()
    {
        return hasWon(CROSS);
    }

    public boolean isFinished()
    {
        return finished;
    }

    public Boolean[] getBoard()
    {
        return field;
    }

    public void move()
    {
        for(int i = 0; i < GOOD_MOVES.length; i++)
        {
            if(field[GOOD_MOVES[i]] == EMPTY)
            {
                field[GOOD_MOVES[i]] = CIRCLE;
                return;
            }
        }
    }

    public void set(int i) throws IllegalArgumentException
    {
        if(field[i] == EMPTY)
        {
            field[i] = CROSS;
        }
        else
        {
            throw new IllegalArgumentException("Feld bereits belegt");
        }
    }
}