package chapter8.jsf.tictactoe;

import java.io.Serializable;

import javax.enterprise.context.SessionScoped;
import javax.faces.event.ActionEvent;
import javax.inject.Named;

@SuppressWarnings("serial")
@Named("tttHandler")
@SessionScoped
public class TicTacToeHandler implements Serializable
{
    private static final String CIRCLE_SYMBOL = "O";
    private static final String CROSS_SYMBOL = "X";
    private static final String EMPTY_SYMBOL = " ";

    private Board board;
    private String message;

    public TicTacToeHandler()
    {
        newGame();
    }

    public String newGame()
    {
        board = new Board();
        message = "";
        return null;
    }

    public String getMessage()
    {
        return message;
    }

    public String[] getSymbol()
    {
        String[] field = new String[9];
        for(int i = 0; i < board.getBoard().length; i++)
        {
            if(board.getBoard()[i] == Board.CIRCLE)
            {
                field[i] = CIRCLE_SYMBOL;
            }
            else if(board.getBoard()[i] == Board.CROSS)
            {
                field[i] = CROSS_SYMBOL;
            }
            else
            {
                field[i] = EMPTY_SYMBOL;
            }
        }
        return field;
    }

    public void move(ActionEvent ae)
    {
        if(board.isFinished())
        {
            return;
        }
        try
        {
            board.set(Integer.valueOf(ae.getComponent().getId().split("-")[1]));
            if(board.hasLost())
            {
                message = "Herzlichen Glckwunsch, Sie haben gewonnen!";
                return;
            }
            board.move();
            if(board.hasWon())
            {
                message = "Sie haben leider verloren!";
            }
        }
        catch(Exception e)
        {
        }
    }
}
