package chapter8.servlets;

import java.io.*;
import jakarta.servlet.*;
import jakarta.servlet.annotation.*;
import jakarta.servlet.http.*;

@WebServlet("/HalloWelt")
public class HelloWorldServlet extends HttpServlet
{
    private static final long serialVersionUID = -897846265692477184L;
    private int counter;

    public void init()
    {
        System.out.println("method init of HelloWorld servlet called");
    }

    protected void doGet(HttpServletRequest request, HttpServletResponse response)
              throws IOException, ServletException
    {
        System.out.println("method doGet of HelloWorld servlet called");

        response.setContentType("text/html");
        PrintWriter out = response.getWriter();
        out.println("<html>");
        out.println("<head>");
        out.println("<title>Hallo Welt!</title>");
        out.println("</head>");
        out.println("<body>");
        out.println("<h1>Hallo Welt!</h1>");
        synchronized(this)
        {
        	counter++;
            out.println("<p>Servlet wird zum " + counter + ".Mal aufgerufen!</p>");        	
        }
        out.println("</body>");
        out.println("</html>");
    }
}
