package chapter8.servlets;

import java.io.*;
import jakarta.servlet.*;
import jakarta.servlet.annotation.*;
import jakarta.servlet.http.*;

@WebServlet(urlPatterns="/Zuruecksetzen", loadOnStartup=1)
public class ResetServlet extends HttpServlet
{
    private static final long serialVersionUID = 7968546825609574805L;

    public void init()
    {
        Counter counter = new Counter();
        ServletContext ctx = getServletContext();
        ctx.setAttribute("Counter", counter);
    }
    
    public void doPost(HttpServletRequest request, HttpServletResponse response)
        throws IOException, ServletException
    {
        response.setContentType("text/html");
        PrintWriter out = response.getWriter();
        out.println("<html>");
        out.println("<head>");
        out.println("<title>Z&auml;hler</title>");
        out.println("</head>");
        out.println("<body>");
        out.println("<h1>Zur&uuml;cksetzen des Z&auml;hlers</h1>");

        ServletContext ctx = getServletContext();
        Counter counter = (Counter)ctx.getAttribute("Counter");
        int value = counter.reset();
        out.println("<p>Der Z&auml;hler wurde auf " + value
                    + " zur&uuml;ckgesetzt.</p>");
        
        out.println("</body>");
        out.println("</html>");
    }
}
