package chapter8.servlets;

import java.io.*;
import jakarta.servlet.*;
import jakarta.servlet.annotation.*;
import jakarta.servlet.http.*;

@SuppressWarnings("serial")
@WebServlet("/SchlafenAbfragen")
public class SleepingPollingSessionServlet extends HttpServlet
{
    protected void doGet(HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException
    {
        response.setContentType("text/html");
        PrintWriter out = response.getWriter();
        out.println("<html>");
        out.println("<head>");
        out.println("<title>Schlafen mit Abfragen</title>");
        out.println("</head>");
        out.println("<body>");
        out.println("<h1>Schlafen mit Abfragen</h1>");
        HttpSession session = request.getSession(false);
        if (session != null)
        {
            SleepingThread t;
            t = (SleepingThread) session.getAttribute("SleepingThread");
            if (t != null)
            {
                if (t.isAlive())
                {
                    out.println("<p>Der Auftrag ist noch nicht beendet!</p>");
                    response.setHeader("Refresh", "5");
                }
                else
                {
                    out.println("<p>Der Auftrag ist beendet!</p>");
                    try
                    {
                        t.join();
                    }
                    catch(InterruptedException e)
                    {
                    }
                    out.println("<p>Das Ergebnis lautet: " + t.getMessage() + "</p>");
                    out.println("<a href=\"SchlafenSitzung\">Zur&uuml;ck!</a>");
                    session.invalidate();
                }
            }
            else // t nicht in Session
            {
                out.println("<p>Fehler: Der Auftrag ist unbekannt!</p>");
                out.println("<a href=\"SchlafenSitzung\">Zur&uuml;ck!</a>");
            }
        }
        else // session == null
        {
            out.println("<p>Fehler: Es gibt keine Sitzung!</p>");
            out.println("<a href=\"SchlafenSitzung\">Zur&uuml;ck!</a>");
        }
        out.println("</body>");
        out.println("</html>");
    }
}