package chapter8.servlets;

import java.io.*;
import jakarta.servlet.*;
import jakarta.servlet.annotation.*;
import jakarta.servlet.http.*;

@WebServlet("/Schlafen")
public class SleepingServlet extends HttpServlet
{
    private static final long serialVersionUID = 7968546825609574805L;

    public void doGet(HttpServletRequest request, HttpServletResponse response)
        throws IOException, ServletException
    {
        response.setContentType("text/html");
        PrintWriter out = response.getWriter();
        out.println("<html>");
        out.println("<head>");
        out.println("<title>Ergebnis</title>");
        out.println("</head>");
        out.println("<body>");

        try
        {
            String timeString = request.getParameter("Zeit");
            int time = Integer.parseInt(timeString);
            Thread.sleep(time * 1000);
            out.println("<h1>Gut geschlafen!</h1>");
            out.println("Nun bin ich wieder wach. Ich habe "
                        + time + " Sekunde(n) geschlafen.");
        }
        catch(Exception e)
        {
            out.println("<h1>Fehler</h1>");
            out.println("Es ist folgende Exception passiert:<BR>" + e);
        }

        out.println("</body>");
        out.println("</html>");
    }

    public synchronized void doPost(HttpServletRequest request, HttpServletResponse response)
        throws IOException, ServletException
    {
        doGet(request, response);
    }
}
