package chapter8.servlets;

import java.io.*;
import jakarta.servlet.*;
import jakarta.servlet.annotation.*;
import jakarta.servlet.http.*;

@SuppressWarnings("serial")
@WebServlet("/SchlafenSitzung")
public class SleepingSessionServlet extends HttpServlet
{
    protected void doGet(HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException
    {
        response.setContentType("text/html");
        PrintWriter out = response.getWriter();
        out.println("<html>");
        out.println("<head>");
        out.println("<title>Schlafen mit Abfragen</title>");
        out.println("</head>");
        out.println("<body>");
        out.println("<h1>Schlafen mit Abfragen</h1>");
        String secsString = request.getParameter("Sekunden");
        if (secsString != null)
        {
            try
            {
                int secs = Integer.parseInt(secsString);
                if (secs < 0)
                {
                    throw new NumberFormatException();
                }
                SleepingThread t = new SleepingThread(secs);
                t.start();
                HttpSession session = request.getSession(true);
                session.setMaxInactiveInterval(10);
                session.setAttribute("SleepingThread", t);
                response.setHeader("Refresh", "2; URL=SchlafenAbfragen");
                out.println("<p>Der Auftrag wurde gestartet!");
                out.println("Sie werden automatisch " + "weitergeleitet ...</p>");
                out.println("</body>");
                out.println("</html>");
                return;
            }
            catch(NumberFormatException e)
            {
                out.println("<p>Es muss eine nicht negative Zahl " + "eingegeben werden.</p>");
            }
        }
        out.println("<h2>GET-Formular");
        out.println("<form method=\"get\">");
        out.println("<input name=\"Sekunden\">");
        out.println("<input type=\"submit\" value=\"Los!\">");
        out.println("</form");
        out.println("<h2>POST-Formular");
        out.println("<form method=\"post\">");
        out.println("<input name=\"Sekunden\">");
        out.println("<input type=\"submit\" value=\"Los!\">");
        out.println("</form");
        out.println("</body>");
        out.println("</html>");
    }

    protected void doPost(HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException
    {
        doGet(request, response);
    }
}