package chapter9.apigateway.client.gui;

import chapter9.apigateway.client.model.Cd;
import javafx.geometry.Insets;
import javafx.scene.Scene;
import javafx.scene.control.*;
import javafx.scene.layout.*;
import javafx.stage.Modality;
import javafx.stage.Stage;

enum Operation
{
    ADD, CHANGE
}

public class AddChangeDialog extends Stage
{
    private TextField artistField;
    private TextField titleField;
    private TextField yearField;
    private Button okay;
    private Label status;
    private Cd cd;

    public AddChangeDialog()
    {
        VBox content = new VBox(10);
        content.setPadding(new Insets(10, 10, 10, 10));
        HBox line;

        line = new HBox(10);
        Label artistLabel = new Label("Knstler:");
        line.getChildren().add(artistLabel);
        artistField = new TextField();
        artistField.setPrefWidth(500);
        artistField.setOnAction(e->okay());
        line.getChildren().add(artistField);
        content.getChildren().add(line);

        line = new HBox(10);
        Label titleLabel = new Label("Titel:");
        titleLabel.prefWidthProperty().bind(artistLabel.widthProperty());
        line.getChildren().add(titleLabel);
        titleField = new TextField();
        titleField.prefWidthProperty().bind(artistField.widthProperty());
        titleField.setOnAction(e->okay());
        line.getChildren().add(titleField);
        content.getChildren().add(line);

        line = new HBox(10);
        Label yearLabel = new Label("Jahr:");
        yearLabel.prefWidthProperty().bind(artistLabel.widthProperty());
        line.getChildren().add(yearLabel);
        yearField = new TextField();
        yearField.prefWidthProperty().bind(artistField.widthProperty());
        yearField.setOnAction(e->okay());
        line.getChildren().add(yearField);
        content.getChildren().add(line);

        line = new HBox(10);
        okay = new Button("???");
        okay.setOnAction(e->okay());
        line.getChildren().add(okay);
        Button b = new Button("Abbrechen");
        b.setOnAction(e->cancel());
        line.getChildren().add(b);
        content.getChildren().add(line);

        status = new Label();
        content.getChildren().add(status);

        Scene scene = new Scene(content);
        setScene(scene);
        setTitle("???");
        initModality(Modality.APPLICATION_MODAL);
    }

    public Cd showDialog()
    {
        cd = null;
        showAndWait();
        return cd;
    }

    private void okay()
    {
        String a = artistField.getText();
        a = a.trim();
        if(a.length() == 0)
        {
            status.setText("ungltige Tetxeingabe fr Knstler");
            return;
        }
        String t = titleField.getText();
        t = t.trim();
        if(t.length() == 0)
        {
            status.setText("ungltige Tetxeingabe fr Titel");
            return;
        }
        String y = yearField.getText();
        y = y.trim();
        if(y.length() == 0)
        {
            status.setText("ungltige Tetxeingabe fr Jahr");
            return;
        }

        cd = new Cd(a, t, y);
        close();
    }

    private void cancel()
    {
        close();
    }

    public void prepareAddOperation()
    {
        artistField.setText("");
        titleField.setText("");
        yearField.setText("");
        status.setText("");
        setTitle("Dialog zum Hinzufgen");
        okay.setText("Hinzufgen");
    }

    public void prepareChangeOperation(Cd cd)
    {
        artistField.setText(cd.getArtist());
        titleField.setText(cd.getTitle());
        yearField.setText(cd.getYear());
        status.setText("");
        setTitle("Dialog zum ndern");
        okay.setText("ndern");
    }
}
