package chapter9.apigateway.client.model;

import java.util.*;
import com.google.gson.*;

public class Cd
{
    private String id;
    private String artist;
    private String title;
    private String year;

    public Cd(String id, String artist, String title, String year)
    {
        this.id = id;
        this.artist = artist;
        this.title = title;
        this.year = year;
    }

    public Cd(String artist, String title, String year)
    {
        this(null, artist, title, year);
    }

    public Cd(String json)
    {
        Gson gson = new Gson();
        Cd request = gson.fromJson(json, Cd.class);
        this.id = request.getId();
        this.artist = request.getArtist();
        this.title = request.getTitle();
        this.year = request.getYear();
    }

    public String toString()
    {
        String a = artist;
        String t = title;
        if(artist == null)
        {
            a = "<UNBEKANNT>";
        }
        if(title == null)
        {
            t = "<UNBEKANNT>";
        }
        StringBuffer result = new StringBuffer();
        result.append(a).append(" --- " ).append(t);
        if(year != null)
        {
            result.append(" (").append(year).append(")");
        }
        return result.toString();
    }

    public String toJson()
    {
        Gson gson = new GsonBuilder().create();
        return gson.toJson(this);
    }

    public String getId()
    {
        return id;
    }

    public void setId(String id)
    {
        this.id = id;
    }

    public String getArtist()
    {
        return artist;
    }

    public void setArtist(String artist)
    {
        this.artist = artist;
    }

    public String getTitle()
    {
        return title;
    }

    public void setTitle(String title)
    {
        this.title = title;
    }

    public String getYear()
    {
        return year;
    }

    public void setYear(String year)
    {
        this.year = year;
    }
    
    @SuppressWarnings("unchecked")
    public static void main(String[] args)
    {
        Cd cd = new Cd("Mark Knopfler", "Philadelphia", "2002");
        System.out.println(cd);
        System.out.println(cd.toJson());
        
        cd = new Cd("{artist=\"The Beatles\", id=\"1612868705612-1224960222743\", title=\"Abbey Road\", year=\"1970\"}"); 
        System.out.println(cd);
        System.out.println(cd.toJson());
        
        String jsonString = "{artist:\"Mark Knopfler\",title:\"Philadelphia\",year:\"2002\"}";
        cd = new Cd(jsonString);
        System.out.println(cd.getId() + "/" + cd.getArtist() + "/" + cd.getTitle() + "/" + cd.getYear());
        
        Map<String, Object> retMap = new Gson().fromJson(jsonString, new HashMap<String, Object>().getClass());
        System.out.println(retMap);        
    }
}
