package chapter9.transcribe;

import java.io.InputStream;
import org.reactivestreams.Publisher;
import org.reactivestreams.Subscriber;
import software.amazon.awssdk.services.transcribestreaming.model.AudioStream;

public class AudioStreamPublisher implements Publisher<AudioStream>
{
    private final InputStream inputStream;

    public AudioStreamPublisher(InputStream inputStream)
    {
        this.inputStream = inputStream;
    }

    @Override
    public void subscribe(Subscriber<? super AudioStream> s)
    {
        s.onSubscribe(new ByteToAudioEventSubscription(s, inputStream));
    }
}